import { ZdPage } from '@zeedhi/vue';

const routes = [
	{
		path: '/',
		name: 'dashboard',
		component: ZdPage,
		props: () => ({
			path: 'dashboard',
			local: true,
		}),
	},
	{
		path: '/clientes-por-operador',
		name: 'clientsByOperator',
		component: () => import('../views/ClientesPorOperador/Index.vue'),
	},
	{
		path: '/operadores-por-cliente',
		name: 'operatorsByClient',
		component: () => import('../views/OperadoresPorCliente/Index.vue'),
	},
	{
		path: '/parametrizacao-sla-cliente',
		component: ZdPage,
		name: 'parametrizacaoSlaCliente',
		props: {
			path: 'parametrizacaoSlaCliente/parametrizacaoSlaCliente',
			local: true,
		},
	},
	{
		path: '/versao-bd',
		component: ZdPage,
		name: 'dbVersion',
		props: {
			path: 'dbVersion',
			local: true,
		},
	},
	{
		path: '/teste',
		name: 'test',
		component: () => import('../views/Test.vue'),
	},
	{
		path: '/modules/:module/:page',
		name: 'microservice',
		component: () => import('../views/Microservice.vue'),
	},
	{
		path: '*',
		component: ZdPage,
		props: {
			path: 'notfound',
			local: true,
		},
	},
];

export default routes;
