import { DialogService } from '@zeedhi/common';
import Messages from '@/services/Messages';

export class OmDialogService extends DialogService {
	public static showSuccess(text: string) {
		this.show({
			name: 'success_dialog',
			type: 'success',
			title: 'Sucesso',
			text,
		});
	}

	public static showError(text: string) {
		this.show({
			name: 'error_dialog',
			type: 'error',
			title: 'Erro',
			text,
		});
	}

	public static showErrorBackend(error: any) {
		let msg = '';
		if (error.response && error.response.data && error.response.data.error) {
			msg = `<b>${error.response.data.error}</b>`;
		} else {
			msg = Messages.ERROR_DEAFULT;
		}
		this.show({
			name: 'error_dialog',
			type: 'error',
			title: 'Erro',
			text: msg,
		});
	}
}
