import store from '@/store';
import Vue from 'vue';
import { Component } from 'vue-property-decorator';
import { Config } from '@zeedhi/core';

/**
 * Microservice
 */
@Component
export default class Mircroservice extends Vue {
	private page: string = '';

	public microservicePath() {
		const { module, page } = store.getters.routerParams;
		this.setProductInfoLocalStorage();

		if (process.env.NODE_ENV === 'production') {
			return `/${module}`;
		}

		const userAuth = JSON.stringify({
			LOGIN_TOKEN: localStorage.getItem('LOGIN_TOKEN'),
			LOGIN_USER: localStorage.getItem('LOGIN_USER'),
			LOGIN_USER_NAME: localStorage.getItem('LOGIN_USER_NAME'),
			LOGIN_LANGUAGE: localStorage.getItem('LOGIN_LANGUAGE'),
			LOGIN_HASH: localStorage.getItem('LOGIN_HASH'),
			LOGIN_KEEP_CONNECTED: localStorage.getItem('LOGIN_KEEP_CONNECTED'),
		});

		const productInfo = JSON.stringify({
			PRODUCT_ID: Config.env.product.id,
			PRODUCT_URL: Config.env.product.url,
			PRODUCT_LOGO_URL: Config.env.product.logoUrl,
			PRODUCT_BACKGROUND_IMG_PATH: Config.env.loginBackgroundImgUrl,
		});

		if (!this.page) {
			this.page = page;
		}
		return `${Config.env.modules[module].baseUrl}?page=${this.page}&user_auth=${userAuth}&product_info=${productInfo}`;
	}

	private setProductInfoLocalStorage() {
		localStorage.setItem('PRODUCT_ID', Config.env.product.id);
		localStorage.setItem('PRODUCT_URL', Config.env.product.url);
		localStorage.setItem('PRODUCT_LOGO_URL', Config.env.product.logoUrl);
		localStorage.setItem('PRODUCT_BACKGROUND_IMG_PATH', Config.env.loginBackgroundImgUrl);
	}
}
